package app16a.action;

import app16a.dao.CustomerDAO;
import app16a.dao.DAOFactory;
import app16a.form.CustomerSearchCriteriaForm;
import app16a.to.CustomerSearchCriteriaTO;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

public class SearchCustomerAction extends Action {

  public ActionForward execute(ActionMapping mapping, ActionForm form,
    HttpServletRequest request, HttpServletResponse response) {
    
    ActionMessages actionMessages = new ActionMessages();
    
    CustomerSearchCriteriaForm customerForm = (CustomerSearchCriteriaForm) form;
    CustomerSearchCriteriaTO customerSearch = new CustomerSearchCriteriaTO();
    ArrayList customerList = new ArrayList();      
    
  	customerSearch.setName(customerForm.getName()); 	
    customerSearch.setAddress(customerForm.getAddress());   
    customerSearch.setPhone(customerForm.getPhone());
    CustomerDAO customerDAO = DAOFactory.getInstance().getCustomerDAO();
    try {
      customerList = customerDAO.searchCustomers(customerSearch);
      request.setAttribute("customerList", customerList);
      return (mapping.getInputForward());
    }
    catch (Exception ex) {  
      actionMessages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("failed.search"));
      saveMessages(request, actionMessages);
      return (mapping.findForward("failed"));
    }    
  }
}
